diff -urB nagios-HEAD/cgi/cgiutils.c nagios-3.2.1/cgi/cgiutils.c
--- nagios-HEAD/cgi/cgiutils.c  2009-07-31 09:54:20.000000000 -0700
+++ nagios-3.2.1/cgi/cgiutils.c 2010-07-07 19:09:37.000000000 -0700
@@ -1749,7 +1749,7 @@

        printf("Last Updated: %s<BR>\n",date_time);
        if(refresh==TRUE)
-               printf("Updated every %d seconds<br>\n",refresh_rate);
+               printf("Updated every %d seconds <small>[<a href=\"javascript:window.location.href += ((window.location.toString().indexOf('?') != -1) ? '&' : '?') + 'paused'\">pause</a>]</small><br>\n",refresh_rate);

        printf("Nagios&reg; Core&trade; %s - <A HREF='http://www.nagios.org' TARGET='_new' CLASS='homepageURL'>www.nagios.org</A><BR>\n",PROGRAM_VERSION);

diff -urB nagios-HEAD/cgi/extinfo.c nagios-3.2.1/cgi/extinfo.c
--- nagios-HEAD/cgi/extinfo.c   2010-06-18 07:25:30.000000000 -0700
+++ nagios-3.2.1/cgi/extinfo.c  2010-07-07 19:09:37.000000000 -0700
@@ -126,6 +126,7 @@
 int sort_option=SORT_NEXTCHECKTIME;

 int embedded=FALSE;
+int refresh=TRUE;
 int display_header=TRUE;


@@ -222,7 +223,7 @@
                else
                        snprintf(temp_buffer,sizeof(temp_buffer)-1,"Nagios Process Information");
                temp_buffer[sizeof(temp_buffer)-1]='\x0';
-               display_info_table(temp_buffer,TRUE,&current_authdata);
+               display_info_table(temp_buffer,refresh,&current_authdata);

                /* find the host */
                if(display_type==DISPLAY_HOST_INFO || display_type==DISPLAY_SERVICE_INFO){
@@ -584,7 +585,9 @@

        printf("Cache-Control: no-store\r\n");
        printf("Pragma: no-cache\r\n");
-       printf("Refresh: %d\r\n",refresh_rate);
+
+       if(refresh==TRUE)
+               printf("Refresh: %d\r\n",refresh_rate);

        time(&current_time);
        get_time_string(&current_time,date_time,(int)sizeof(date_time),HTTP_DATE_TIME);
@@ -765,6 +768,10 @@
                /* we found the noheader option */
                else if(!strcmp(variables[x],"noheader"))
                        display_header=FALSE;
+
+               /* we found the pause option */
+               else if(!strcmp(variables[x],"paused"))
+                       refresh=FALSE;
                }

        /* free memory allocated to the CGI variables */
diff -urB nagios-HEAD/cgi/outages.c nagios-3.2.1/cgi/outages.c
--- nagios-HEAD/cgi/outages.c   2008-11-30 09:22:58.000000000 -0800
+++ nagios-3.2.1/cgi/outages.c  2010-07-07 19:09:37.000000000 -0700
@@ -95,6 +95,7 @@
 int service_severity_divisor=4;            /* default = services are 1/4 as important as hosts */

 int embedded=FALSE;
+int refresh=TRUE;
 int display_header=TRUE;


@@ -160,7 +161,7 @@

                /* left column of the first row */
                printf("<td align=left valign=top width=33%%>\n");
-               display_info_table("Network Outages",TRUE,&current_authdata);
+               display_info_table("Network Outages",refresh,&current_authdata);
                printf("</td>\n");

                /* middle column of top row */
@@ -205,7 +206,9 @@

        printf("Cache-Control: no-store\r\n");
        printf("Pragma: no-cache\r\n");
-       printf("Refresh: %d\r\n",refresh_rate);
+
+       if(refresh==TRUE)
+               printf("Refresh: %d\r\n",refresh_rate);

        time(&current_time);
        get_time_string(&current_time,date_time,(int)sizeof(date_time),HTTP_DATE_TIME);
@@ -293,6 +296,10 @@
                /* we found the noheader option */
                else if(!strcmp(variables[x],"noheader"))
                        display_header=FALSE;
+
+               /* we found the pause option */
+               else if(!strcmp(variables[x],"paused"))
+                       refresh=FALSE;
                }

        /* free memory allocated to the CGI variables */
diff -urB nagios-HEAD/cgi/status.c nagios-3.2.1/cgi/status.c
--- nagios-HEAD/cgi/status.c    2009-09-11 16:55:30.000000000 -0700
+++ nagios-3.2.1/cgi/status.c   2010-07-07 19:09:37.000000000 -0700
@@ -177,6 +177,7 @@
 int problem_services_unknown=0;

 int embedded=FALSE;
+int refresh=TRUE;
 int display_header=TRUE;


@@ -312,7 +313,7 @@
                printf("<td align=left valign=top width=33%%>\n");

                /* info table */
-               display_info_table("Current Network Status",TRUE,&current_authdata);
+               display_info_table("Current Network Status",refresh,&current_authdata);

                printf("<TABLE BORDER=1 CELLPADDING=0 CELLSPACING=0 CLASS='linkBox'>\n");
                printf("<TR><TD CLASS='linkBox'>\n");
@@ -515,7 +516,9 @@

        printf("Cache-Control: no-store\r\n");
        printf("Pragma: no-cache\r\n");
-       printf("Refresh: %d\r\n",refresh_rate);
+
+       if(refresh==TRUE)
+               printf("Refresh: %d\r\n",refresh_rate);

        get_time_string(&current_time,date_time,(int)sizeof(date_time),HTTP_DATE_TIME);
        printf("Last-Modified: %s\r\n",date_time);
@@ -765,7 +768,11 @@
                         service_filter=strdup(variables[x]);
                        strip_html_brackets(service_filter);
                         }
-               }
+
+               /* we found the pause option */
+               else if(!strcmp(variables[x],"paused"))
+                       refresh=FALSE;
+               }

        /* free memory allocated to the CGI variables */
        free_cgivars(variables);
diff -urB nagios-HEAD/cgi/statusmap.c nagios-3.2.1/cgi/statusmap.c
--- nagios-HEAD/cgi/statusmap.c 2009-07-07 15:19:45.000000000 -0700
+++ nagios-3.2.1/cgi/statusmap.c        2010-07-07 19:09:37.000000000 -0700
@@ -178,6 +178,7 @@
 char *host_name="all";

 int embedded=FALSE;
+int refresh=TRUE;
 int display_header=TRUE;
 int display_popups=TRUE;
 int use_links=TRUE;
@@ -314,7 +315,9 @@
        if(create_type==CREATE_HTML){
                printf("Cache-Control: no-store\r\n");
                printf("Pragma: no-cache\r\n");
-               printf("Refresh: %d\r\n",refresh_rate);
+
+               if(refresh=TRUE)
+                       printf("Refresh: %d\r\n",refresh_rate);

                time(&current_time);
                get_time_string(&current_time,date_time,sizeof(date_time),HTTP_DATE_TIME);
@@ -580,6 +583,10 @@
                        strip_html_brackets(variables[x]);
                        add_layer(variables[x]);
                        }
+
+               /* we found the pause option */
+               else if(!strcmp(variables[x],"paused"))
+                       refresh=FALSE;
                }

        /* free memory allocated to the CGI variables */
@@ -620,7 +627,7 @@
                else
                        snprintf(temp_buffer,sizeof(temp_buffer)-1,"Network Map For Host <I>%s</I>",host_name);
                temp_buffer[sizeof(temp_buffer)-1]='\x0';
-               display_info_table(temp_buffer,TRUE,&current_authdata);
+               display_info_table(temp_buffer,refresh,&current_authdata);

                printf("<TABLE BORDER=1 CELLPADDING=0 CELLSPACING=0 CLASS='linkBox'>\n");
                printf("<TR><TD CLASS='linkBox'>\n");
diff -urB nagios-HEAD/cgi/tac.c nagios-3.2.1/cgi/tac.c
--- nagios-HEAD/cgi/tac.c       2008-11-30 09:44:20.000000000 -0800
+++ nagios-3.2.1/cgi/tac.c      2010-07-07 19:16:27.000000000 -0700
@@ -94,6 +94,7 @@
 authdata current_authdata;

 int embedded=FALSE;
+int refresh=TRUE;
 int display_header=FALSE;

 hostoutage *hostoutage_list=NULL;
@@ -273,7 +274,7 @@

                /* left column of top table - info box */
                printf("<td align=left valign=top width=33%%>\n");
-               display_info_table("Tactical Status Overview",TRUE,&current_authdata);
+               display_info_table("Tactical Status Overview",refresh,&current_authdata);
                printf("</td>\n");

                /* middle column of top table - log file navigation options */
@@ -371,7 +372,9 @@

        printf("Cache-Control: no-store\r\n");
        printf("Pragma: no-cache\r\n");
-       printf("Refresh: %d\r\n",refresh_rate);
+
+       if(refresh=TRUE)
+               printf("Refresh: %d\r\n",refresh_rate);

        time(&current_time);
        get_time_string(&current_time,date_time,(int)sizeof(date_time),HTTP_DATE_TIME);
@@ -445,6 +448,10 @@
                else if(!strcmp(variables[x],"noheader"))
                        display_header=FALSE;

+               /* we found the pause option */
+               else if(!strcmp(variables[x],"paused"))
+                       refresh=FALSE;
+
                /* we received an invalid argument */
                else
                        error=TRUE;
@@ -945,7 +952,7 @@
        /* left column */
        printf("<td align=left valign=top width=50%%>\n");

-       display_info_table("Tactical Monitoring Overview",TRUE,&current_authdata);
+       display_info_table("Tactical Monitoring Overview",refresh,&current_authdata);

        printf("</td>\n");

